import { world, system } from "@minecraft/server";

function getRandom(chance){
    if (chance <= Math.random()){
        return true
    }else{
        return false
    }
}

function timerInTransVP(player) {
    system.runTimeout(eventData => {
        player.runCommandAsync('tellraw @s[tag=transVpdInit,tag=!vpd] {"rawtext":[{"translate":"vpd.sangramentoEndT"}]}')
        player.runCommandAsync('tag @s[tag=transVpdInit,tag=!vpd] remove transVpdInit')
    }, 24000)
}

world.afterEvents.entityHurt.subscribe(eventData => {
    if (getRandom(0.5) && eventData.damageSource.damagingEntity.typeId == "sunrise:vampire_original" || eventData.damageSource.damagingEntity.typeId == "sunrise:vampire") {
        if (eventData.hurtEntity.hasTag("transVpdInit") == false && eventData.hurtEntity.hasTag("vpd") == false) {
            eventData.hurtEntity.runCommandAsync('tellraw @s {"rawtext":[{"translate":"vpd.sangramentoIniT"}]}')
            eventData.hurtEntity.runCommandAsync('tag @s add transVpdInit')
            timerInTransVP(eventData.hurtEntity)
        }
    }
})

world.afterEvents.entityDie.subscribe(eventData => {
    if (eventData.deadEntity.hasTag("transVpdInit") && eventData.deadEntity.hasTag("vpd") == false) {
        eventData.deadEntity.runCommandAsync("tag @s remove transVpdInit")
        eventData.deadEntity.runCommandAsync("function vampire/transform")
        if (getRandom(0.3)){
            eventData.deadEntity.runCommandAsync("tag @s add vpd_plus")
        }
    }
}
)