import { world, system } from "@minecraft/server";

function getRandom(chance) {
    if (chance <= Math.random()) {
        return true
    } else {
        return false
    }
}

world.afterEvents.entityDie.subscribe(eventData => {
    if (eventData.damageSource.damagingEntity.hasTag("vpd_plus")) {
        if (getRandom(0.075) && eventData.deadEntity.typeId == "sunrise:vampire" || getRandom(0.6) && eventData.deadEntity.typeId == "sunrise:vampire_original") {
            eventData.damageSource.damagingEntity.runCommand("tag @s add vpd_runlucks")
        }
    }else if (eventData.damageSource.damagingEntity.hasTag("vpd")){
        if (getRandom(0.25) && eventData.deadEntity.typeId == "sunrise:vampire" || getRandom(0.3) && eventData.deadEntity.typeId == "sunrise:vampire_original") {
            eventData.damageSource.damagingEntity.runCommand("tag @s add vpd_runlucks")
        }
    }
})

world.afterEvents.itemCompleteUse.subscribe(eventData => {
    if (eventData.itemStack.typeId == 'sunrise:blood_vampire' && getRandom(0.15)) {
        eventData.damageSource.damagingEntity.runCommand("tag @s add vpd_runlucks")
    }
});